/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Sep.14.1999  Programing start

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <time.h>
#include <gtk/gtk.h>
#include  "rr_main.h"
#include  "rr_screen.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- եåǡ */
#include  "../picture/anim01.xpm"
#include  "../picture/anim02.xpm"
#include  "../picture/anim03.xpm"


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ᥤ󥦥ɥ */
GtkWidget *win;

/* --- ɽ륭饯 */
GdkPixmap *pic[3];
GdkBitmap *mask[3];


/* --- ִ */
gint  timer_handle;
gint  timer, max;



/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(GtkWidget *screen)
{
  GdkPixmap *screen_buf;
  GtkWidget  *label;

  win = screen;
  timer = 0;

  /* -- եå pixmap  */
  pic[0] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[0],
					NULL,
					anim01);
  pic[1] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[1],
					NULL,
					anim02);
  pic[2] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[2],
					NULL,
					anim03);

  /* -- ǥեȥեå */
  RRScreenPutPixmap(pic[0], 0, 0);
  RRScreenSwitch();
  RRScreenPutPixmap(pic[0], 0, 0);
  RRScreenSwitch();
  screen_buf = RRScreenBuffer();
  gdk_gc_set_clip_mask(RRScreenGCGet(), NULL);
  gdk_gc_set_clip_origin(RRScreenGCGet(), 0, 0);
  gdk_draw_pixmap(screen_buf, RRScreenGCGet(), pic[0], 0, 0,
		  0, 0, 81, 81);

  /* -- ʸ٥ */
  label = RRGetParts(RRGetParts(win, "fixed1"), "label1");
  gtk_label_set_text(GTK_LABEL(label), "");

  /* --- ߥޡεư */
  timer_handle = gtk_timeout_add(500, (GtkFunction)RRMainBefore, NULL);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  gdk_pixmap_unref(pic[0]);
  gdk_pixmap_unref(pic[1]);
  gdk_pixmap_unref(pic[2]);
  gdk_bitmap_unref(mask[0]);
  gdk_bitmap_unref(mask[1]);
  gdk_bitmap_unref(mask[2]);
}


/* -------------------------------------------------------------
  RRMainStart      -- ֤˥뤵ᥤ

   return : void
   gint time - ȥ
-------------------------------------------------------------- */
void RRMainStart(gint time)
{
  GtkWidget  *b;

  timer = max = time;

  /* --  */
  gtk_timeout_remove(timer_handle);

  /* --- ߥޡεư */
  timer_handle = gtk_timeout_add(1000, (GtkFunction)RRMain, NULL);

  /* --- ܥξõ */
  b = RRGetParts(RRGetParts(win, "fixed1"), "button1");
  gtk_widget_hide(b);
  b = RRGetParts(RRGetParts(win, "fixed1"), "button2");
  gtk_widget_hide(b);
  b = RRGetParts(RRGetParts(win, "fixed1"), "button3");
  gtk_widget_hide(b);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  GtkWidget  *label, *b;
  gchar   str[128];
  gfloat  step;

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  if ((--timer) == 0) {
    /* -- ɤ֤γ */
    RRScreenPutPixmap(pic[2], 0, 0);
    RRScreenSwitch();
    /* -- λܥ */
    b = RRGetParts(RRGetParts(win, "fixed1"), "button4");
    gtk_widget_show(b);
    /* -- ʸ٥ */
    label = RRGetParts(RRGetParts(win, "fixed1"), "label1");
    gtk_label_set_text(GTK_LABEL(label), "Ǥ");
    /* --  */
    gtk_timeout_remove(timer_handle);
    /* -- ץ쥹С */
    gtk_progress_bar_update(GTK_PROGRESS_BAR(RRGetParts(RRGetParts(win, "fixed1"), "timebar")), 1);
  }
  else {
    /* -- γ */
    RRScreenPutPixmap(pic[(timer%2)], 0, 0);
    /* -- ʸ٥ */
    sprintf(str, " %dä", timer);
    label = RRGetParts(RRGetParts(win, "fixed1"), "label1");
    gtk_label_set_text(GTK_LABEL(label), str);
    /* -- ץ쥹С */
    step = (gfloat)(max - timer) / (gfloat)max;
    gtk_progress_bar_update(GTK_PROGRESS_BAR(RRGetParts(RRGetParts(win, "fixed1"), "timebar")), step);
  }

  return 1;
}

/* -------------------------------------------------------------
  RRMainBefore       -- ޡư˥եåɽ뤿ˡ

   return : void
   void
-------------------------------------------------------------- */
gint RRMainBefore(gpointer gdata)
{
  /* --- Graphic Buffer Υå */
  RRScreenSwitch();
  RRScreenPutPixmap(pic[0], 0, 0);

  return 1;
}

